<?php
/**
 * DokuWiki Plugin simplebpmn (Action Component)
 *
 * @license GPL 2 http://www.gnu.org/licenses/gpl-2.0.html
 * @author  Urszula Ciaputa <u.ciaputa@gmail.com>
 */
 
if (!defined('DOKU_INC')) die();
if (!defined('DOKU_PLUGIN')) define('DOKU_PLUGIN', DOKU_INC . 'lib/plugins/');
require_once (DOKU_PLUGIN . 'action.php');
 
class action_plugin_simplebpmn_wysiwyg extends DokuWiki_Action_Plugin {

	/**
	 * Register the eventhandlers
	 */
	function register(&$controller) {
		$controller->register_hook('TOOLBAR_DEFINE', 'AFTER', $this, 'bpmn_button', array ());
		$controller->register_hook('TOOLBAR_DEFINE', 'AFTER', $this, 'converter_button', array ());
	}
 
	/**
	 * Inserts the BPMN toolbar button
	 */
	function bpmn_button(&$event, $param) {
		$event->data[] = array (
			'type' => 'format',
			'title' => 'SimpleBPMN Notation',
			'icon' => '../../plugins/simplebpmn/img/bpmn_button.png',
			'open' => '<bpmn subprocesses=collapse diagram=before>',
			'close' => '</bpmn>',
		);
	}

	/**
	 * Inserts the converter toolbar button
	 */
	function converter_button(&$event, $param) {
		$event->data[] = array (
			'type' => 'mediapopup',
			'title' => 'BPMN XML -> SimpleBPMN Converter',
			'icon' => '../../plugins/simplebpmn/img/converter_button.png',
			'name' => 'BPMN XML -> SimpleBPMN Converter',
			'url' => 'lib/plugins/simplebpmn/converter.php?',
			'options' => 'height=428,width=600,top=100,left=100,location=no,menubar=no,status=no,toolbar=no'
		);
	}
}
